package org.apache.bcel.generic;

package .var.folders._j.vfbv187d0bb8b8w5spzgg8180000gn.T;

import java.io.DataOutputStream;
import java.io.IOException;
import org.apache.bcel.generic.InstructionHandle;
import org.apache.bcel.generic.Select;
import org.apache.bcel.generic.Visitor;
import org.apache.bcel.util.ByteSequence;

public class TABLESWITCH extends Select {
  TABLESWITCH() {}
  
  public TABLESWITCH(int[] match, InstructionHandle[] targets, InstructionHandle defaultTarget) {
    super((short)170, match, targets, defaultTarget);
    short length = (short)(13 + getMatchLength() * 4);
    setLength(length);
    setFixedLength(length);
  }
  
  public void accept(Visitor v) {
    v.visitVariableLengthInstruction(this);
    v.visitStackConsumer(this);
    v.visitBranchInstruction(this);
    v.visitSelect(this);
    v.visitTABLESWITCH(this);
  }
  
  public void dump(DataOutputStream out) throws IOException {
    super.dump(out);
    int matchLength = getMatchLength();
    int low = (matchLength > 0) ? getMatch(0) : 0;
    out.writeInt(low);
    int high = (matchLength > 0) ? getMatch(matchLength - 1) : 0;
    out.writeInt(high);
    for (int i = 0; i < matchLength; i++)
      out.writeInt(setIndices(i, getTargetOffset(getTarget(i)))); 
  }
  
  protected void initFromFile(ByteSequence bytes, boolean wide) throws IOException {
    super.initFromFile(bytes, wide);
    int low = bytes.readInt();
    int high = bytes.readInt();
    int matchLength = high - low + 1;
    setMatchLength(matchLength);
    short fixedLength = (short)(13 + matchLength * 4);
    setFixedLength(fixedLength);
    setLength((short)(fixedLength + getPadding()));
    setMatches(new int[matchLength]);
    setIndices(new int[matchLength]);
    setTargets(new InstructionHandle[matchLength]);
    for (int i = 0; i < matchLength; i++) {
      setMatch(i, low + i);
      setIndices(i, bytes.readInt());
    } 
  }
}
